import { openBlock as s, createElementBlock as o, createElementVNode as l, toDisplayString as u, renderSlot as c, ref as x, computed as b, normalizeClass as k, unref as _, createVNode as q, withCtx as y, useSlots as N, Fragment as S, renderList as B, createCommentVNode as p, resolveComponent as C, createBlock as $, inject as T, withDirectives as L, isRef as D, vModelDynamic as F, provide as M, vModelSelect as E, vModelText as j, watch as R, normalizeStyle as Z, createTextVNode as z, onMounted as I, withModifiers as A, vModelCheckbox as G, withKeys as H } from "vue";
const X = { class: "cf-action-card" }, J = { class: "cf-action-card__body" }, Q = { class: "cf-action-card__title" }, W = { class: "cf-action-card__body__slot" }, Y = { class: "cf-action-card__action" }, $s = {
  __name: "ActionCard",
  props: {
    title: String
  },
  setup(n) {
    const t = n;
    return (e, a) => (s(), o("div", X, [
      l("div", J, [
        l("div", Q, u(t.title), 1),
        l("div", W, [
          c(e.$slots, "body")
        ])
      ]),
      l("div", Y, [
        c(e.$slots, "action")
      ])
    ]));
  }
};
const P = (n, t) => {
  const e = n.__vccOpts || n;
  for (const [a, i] of t)
    e[a] = i;
  return e;
}, ee = {}, te = { class: "cf-app-bar" };
function se(n, t) {
  return s(), o("header", te, [
    l("div", null, [
      c(n.$slots, "left")
    ]),
    l("div", null, [
      c(n.$slots, "right")
    ])
  ]);
}
const le = /* @__PURE__ */ P(ee, [["render", se]]);
const oe = { class: "cf-dropdown-body" }, ae = {
  __name: "Dropdown",
  setup(n) {
    const t = x(!1), e = b(() => ({
      "cf-dropdown": !0,
      "cf-dropdown--open": t.value
    }));
    return (a, i) => (s(), o("div", {
      class: k(_(e))
    }, [
      l("div", {
        class: "cf-dropdown-toggle",
        onClick: i[0] || (i[0] = (d) => t.value = !t.value)
      }, [
        c(a.$slots, "toggle")
      ]),
      l("div", oe, [
        c(a.$slots, "body")
      ]),
      l("div", {
        class: "cf-dropdown-backdrop",
        onClick: i[1] || (i[1] = (d) => t.value = !1)
      })
    ], 2));
  }
};
const ne = {
  key: 0,
  class: "cf-app-bar-link"
}, ie = { class: "cf-app-bar-link__label" }, de = /* @__PURE__ */ l("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16"
}, [
  /* @__PURE__ */ l("path", { d: "M14.15 4.492H1.85l-.354.854 6.15 6.15h.707l6.15-6.15-.353-.854z" })
], -1), re = {
  key: 1,
  class: "cf-app-bar-link"
}, ue = { class: "cf-app-bar-link__label" }, ks = {
  __name: "AppBarLink",
  props: {
    dropdown: Boolean
  },
  setup(n) {
    return (t, e) => n.dropdown ? (s(), o("div", ne, [
      q(ae, null, {
        toggle: y(() => [
          l("div", ie, [
            c(t.$slots, "default"),
            de
          ])
        ]),
        body: y(() => [
          c(t.$slots, "dropdown")
        ]),
        _: 3
      })
    ])) : (s(), o("button", re, [
      l("div", ue, [
        c(t.$slots, "default")
      ])
    ]));
  }
};
const ce = {
  key: 0,
  class: "cf-app-view-breadcrumbs"
}, _e = ["href"], pe = { key: 1 }, fe = {
  key: 1,
  class: "cf-app-view-header"
}, ve = { key: 0 }, be = {
  key: 1,
  class: "cf-app-view-header__description"
}, me = {
  key: 2,
  class: "cf-app-view-header__actions"
}, ws = {
  __name: "AppView",
  props: {
    title: String,
    description: String,
    breadcrumbs: Array,
    wide: Boolean
  },
  setup(n) {
    const t = n, e = N(), a = b(() => ({
      "cf-app-view": !0,
      "cf-app-view--wide": t.wide
    }));
    return (i, d) => (s(), o("div", {
      class: k(_(a))
    }, [
      t.breadcrumbs ? (s(), o("ol", ce, [
        (s(!0), o(S, null, B(t.breadcrumbs, (r) => (s(), o("li", {
          key: r.name
        }, [
          r.path ? (s(), o("a", {
            key: 0,
            href: r.path
          }, u(r.name), 9, _e)) : (s(), o("span", pe, u(r.name), 1))
        ]))), 128))
      ])) : p("", !0),
      t.title || t.description || _(e).actions ? (s(), o("div", fe, [
        t.title ? (s(), o("h1", ve, u(t.title), 1)) : p("", !0),
        t.description ? (s(), o("div", be, u(t.description), 1)) : p("", !0),
        _(e).actions ? (s(), o("div", me, [
          c(i.$slots, "actions")
        ])) : p("", !0)
      ])) : p("", !0),
      c(i.$slots, "default")
    ], 2));
  }
};
const xs = {
  __name: "Banner",
  props: {
    type: String
  },
  setup(n) {
    const t = n, e = b(() => ({
      "cf-banner": !0,
      [`cf-banner--${t.type}`]: t.type
    }));
    return (a, i) => (s(), o("div", {
      class: k(_(e))
    }, [
      c(a.$slots, "default")
    ], 2));
  }
}, K = {
  to: {
    type: String,
    default: null
  },
  type: {
    type: String,
    default: "button"
  },
  large: Boolean,
  wide: Boolean,
  color: {
    type: String,
    default: null
  },
  loading: Boolean,
  disabled: Boolean
};
const he = ["type", "disabled"], Ss = {
  __name: "FilledButton",
  props: K,
  setup(n) {
    const t = n, e = b(() => ({
      "cf-button": !0,
      "cf-button--large": t.large,
      "cf-button--wide": t.wide,
      "cf-button--loading": t.loading,
      "cf-button--disabled": t.disabled,
      "cf-filled-button": !0,
      [`cf-filled-button--${t.color}`]: t.color
    }));
    return (a, i) => {
      const d = C("router-link");
      return a.to ? (s(), $(d, {
        key: 0,
        class: k(_(e)),
        to: a.to,
        inert: t.disabled
      }, {
        default: y(() => [
          c(a.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (s(), o("button", {
        key: 1,
        class: k(_(e)),
        type: t.type,
        disabled: t.disabled
      }, [
        c(a.$slots, "default")
      ], 10, he));
    };
  }
};
const ye = ["type", "disabled"], ge = {
  __name: "OutlinedButton",
  props: K,
  setup(n) {
    const t = n, e = b(() => ({
      "cf-button": !0,
      "cf-button--large": t.large,
      "cf-button--wide": t.wide,
      "cf-button--loading": t.loading,
      "cf-button--disabled": t.disabled,
      "cf-outlined-button": !0,
      [`cf-outlined-button--${t.color}`]: t.color
    }));
    return (a, i) => {
      const d = C("router-link");
      return a.to ? (s(), $(d, {
        key: 0,
        class: k(_(e)),
        to: a.to,
        inert: t.disabled
      }, {
        default: y(() => [
          c(a.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (s(), o("button", {
        key: 1,
        class: k(_(e)),
        type: t.type,
        disabled: t.disabled
      }, [
        c(a.$slots, "default")
      ], 10, ye));
    };
  }
};
const $e = ["disabled"], Bs = {
  __name: "TextButton",
  props: {
    to: String,
    disabled: Boolean
  },
  setup(n) {
    const t = n;
    return (e, a) => {
      const i = C("router-link");
      return n.to ? (s(), $(i, {
        key: 0,
        class: "cf-text-button",
        to: n.to,
        inert: t.disabled
      }, {
        default: y(() => [
          c(e.$slots, "default")
        ]),
        _: 3
      }, 8, ["to", "inert"])) : (s(), o("button", {
        key: 1,
        class: "cf-text-button",
        type: "button",
        disabled: t.disabled
      }, [
        c(e.$slots, "default")
      ], 8, $e));
    };
  }
};
const ke = { class: "cf-choice" }, we = ["type", "id", "name", "value", "true-value", "false-value", "required", "disabled"], xe = ["for"], Se = { key: 0 }, Be = {
  __name: "Choice",
  props: {
    modelValue: [Number, String, Boolean, Array],
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    type: String,
    label: String,
    helper: String,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(n, { emit: t }) {
    const e = n, a = Math.random(), i = {
      name: T("choice-list-name", null),
      required: T("choice-list-required", null)
    }, d = b({
      get() {
        return e.modelValue;
      },
      set(r) {
        t("update:modelValue", r);
      }
    });
    return (r, v) => (s(), o("div", ke, [
      L(l("input", {
        "onUpdate:modelValue": v[0] || (v[0] = (h) => D(d) ? d.value = h : null),
        type: e.type,
        id: _(a),
        name: i.name,
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        required: i.required,
        disabled: e.disabled
      }, null, 8, we), [
        [F, _(d)]
      ]),
      l("label", { for: _(a) }, u(e.label || e.value), 9, xe),
      e.helper ? (s(), o("small", Se, u(e.helper), 1)) : p("", !0)
    ]));
  }
};
const Ve = {
  key: 0,
  class: "cf-choice-list__label"
}, Vs = {
  __name: "ChoiceList",
  props: {
    modelValue: [Number, String, Boolean, Array],
    label: String,
    choices: Array,
    multiple: Boolean,
    required: Boolean,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(n, { emit: t }) {
    const e = n, a = b(() => ({
      "cf-choice-list": !0,
      "cf-choice-list--disabled": e.disabled
    })), i = b({
      get() {
        return e.modelValue;
      },
      set(d) {
        t("update:modelValue", d);
      }
    });
    return M("choice-list-name", Math.random()), M("choice-list-required", e.required), (d, r) => (s(), o("div", {
      class: k(_(a))
    }, [
      e.label ? (s(), o("div", Ve, u(e.label), 1)) : p("", !0),
      (s(!0), o(S, null, B(n.choices, (v) => (s(), $(Be, {
        key: v.value || v,
        type: e.multiple ? "checkbox" : "radio",
        label: v.label || v.value || v,
        helper: v.helper,
        value: v.value || v,
        disabled: e.disabled,
        modelValue: _(i),
        "onUpdate:modelValue": r[0] || (r[0] = (h) => D(i) ? i.value = h : null)
      }, null, 8, ["type", "label", "helper", "value", "disabled", "modelValue"]))), 128)),
      c(d.$slots, "default")
    ], 2));
  }
};
const Ce = { class: "cf-field" }, De = ["required", "disabled"], Le = {
  key: 0,
  value: null
}, qe = ["value"], ze = ["required", "disabled"], Ae = ["type", "placeholder", "list", "required", "disabled"], Te = {
  key: 3,
  class: "cf-field__prefix"
}, Me = {
  key: 4,
  class: "cf-field__suffix"
}, Ne = { key: 5 }, Fe = { key: 6 }, Ie = /* @__PURE__ */ l("div", { class: "cf-field__outline" }, null, -1), U = {
  __name: "Field",
  props: {
    modelValue: [Number, String],
    type: String,
    label: String,
    placeholder: String,
    prefix: String,
    suffix: String,
    options: Array,
    list: String,
    helper: String,
    disabled: Boolean,
    required: Boolean
  },
  emits: ["update:modelValue"],
  setup(n, { emit: t }) {
    const e = n, a = b({
      get() {
        return e.modelValue;
      },
      set(i) {
        t("update:modelValue", i);
      }
    });
    return (i, d) => (s(), o("div", Ce, [
      e.type === "select" ? L((s(), o("select", {
        key: 0,
        class: "cf-field__input",
        "onUpdate:modelValue": d[0] || (d[0] = (r) => D(a) ? a.value = r : null),
        required: e.required,
        disabled: e.disabled
      }, [
        !e.required && e.options.length ? (s(), o("option", Le)) : p("", !0),
        (s(!0), o(S, null, B(e.options, (r) => (s(), o("option", {
          key: r.value || r,
          value: r.value || r
        }, u(r.label || r), 9, qe))), 128))
      ], 8, De)), [
        [E, _(a)]
      ]) : e.type === "textarea" ? L((s(), o("textarea", {
        key: 1,
        class: "cf-field__input",
        "onUpdate:modelValue": d[1] || (d[1] = (r) => D(a) ? a.value = r : null),
        required: e.required,
        disabled: e.disabled
      }, null, 8, ze)), [
        [j, _(a)]
      ]) : L((s(), o("input", {
        key: 2,
        class: "cf-field__input",
        "onUpdate:modelValue": d[2] || (d[2] = (r) => D(a) ? a.value = r : null),
        type: e.type,
        placeholder: e.placeholder,
        list: e.list,
        required: e.required,
        disabled: e.disabled
      }, null, 8, Ae)), [
        [F, _(a)]
      ]),
      e.prefix && !["select", "textarea"].includes(e.type) ? (s(), o("div", Te, u(e.prefix), 1)) : p("", !0),
      e.suffix && !["select", "textarea"].includes(e.type) ? (s(), o("div", Me, u(e.suffix), 1)) : p("", !0),
      e.label ? (s(), o("label", Ne, u(e.label), 1)) : p("", !0),
      e.helper ? (s(), o("small", Fe, u(e.helper), 1)) : p("", !0),
      Ie
    ]));
  }
};
const Pe = { class: "cf-data-table-item" }, Ke = {
  key: 0,
  class: "cf-data-table-item__drawer"
}, Ue = { class: "cf-data-table-item__drawer__content" }, Oe = { class: "cf-data-table-item__content" }, Ee = ["data-label"], je = /* @__PURE__ */ l("span", { class: "material-symbols-outlined" }, null, -1), Re = [
  je
], Ze = /* @__PURE__ */ l("span", { class: "material-symbols-outlined" }, null, -1), Ge = {
  __name: "DataTableItem",
  props: {
    data: Object,
    expandable: Boolean
  },
  setup(n) {
    const t = n, e = T("columns", []), a = x(!1);
    return (i, d) => {
      const r = C("router-link");
      return s(), o("div", Pe, [
        a.value ? (s(), o("div", Ke, [
          l("div", Ue, [
            c(i.$slots, "default", {
              item: t.data
            })
          ])
        ])) : p("", !0),
        l("div", Oe, [
          (s(!0), o(S, null, B(_(e), (v) => (s(), o("div", {
            key: v.key,
            "data-label": v.label
          }, u(n.data[v.key]), 9, Ee))), 128))
        ]),
        t.expandable ? (s(), o("button", {
          key: 1,
          class: "cf-data-table-item__toggle",
          onClick: d[0] || (d[0] = (v) => a.value = !a.value)
        }, Re)) : p("", !0),
        t.data.to ? (s(), $(r, {
          key: 2,
          class: "cf-data-table-item__toggle",
          to: t.data.to
        }, {
          default: y(() => [
            Ze
          ]),
          _: 1
        }, 8, ["to"])) : p("", !0),
        t.expandable && a.value ? (s(), o("div", {
          key: 3,
          class: "cf-data-table-item__backdrop",
          onClick: d[1] || (d[1] = (v) => a.value = !1)
        })) : p("", !0)
      ]);
    };
  }
};
const He = { class: "cf-data-table" }, Xe = { class: "cf-data-table__header" }, Je = { class: "cf-data-table__header__content" }, Qe = {
  key: 0,
  class: "cf-data-table__title"
}, We = {
  key: 1,
  class: "cf-data-table__description"
}, Ye = {
  key: 2,
  class: "cf-data-table__search"
}, et = {
  key: 3,
  class: "cf-data-table__actions"
}, tt = {
  key: 0,
  class: "cf-data-table__header__slot"
}, st = { class: "cf-data-table__body__header" }, lt = { class: "cf-data-table__body__items" }, ot = {
  key: 0,
  class: "cf-data-table__footer"
}, at = { class: "cf-data-table__footer__pagination" }, nt = ["disabled"], it = /* @__PURE__ */ l("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ l("path", { d: "M11.022 14.503L4.518 8l6.504-6.504.707.707L5.932 8l5.797 5.796-.707.707z" })
], -1), dt = [
  it
], rt = ["disabled"], ut = /* @__PURE__ */ l("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ l("path", { d: "M4.99 14.503l-.707-.707L10.08 8 4.283 2.203l.707-.707L11.494 8 4.99 14.503z" })
], -1), ct = [
  ut
], _t = { key: 0 }, Cs = {
  __name: "DataTable",
  props: {
    title: String,
    description: String,
    expandable: Boolean,
    paginate: {
      type: Boolean,
      default: !0
    },
    searchKey: String,
    pluralTerm: {
      type: String,
      default: "items"
    },
    itemKey: String,
    pageSize: {
      type: [Number, String],
      default: 10
    },
    columns: {
      type: Array,
      default: []
    },
    data: {
      type: Array,
      default: []
    }
  },
  setup(n) {
    const t = n, e = N(), a = x(""), i = b(() => t.data.filter((f) => {
      if (a.value) {
        const V = f[t.searchKey].replaceAll(" ", "").toLowerCase(), w = a.value.replaceAll(" ", "").toLowerCase();
        return V.includes(w);
      } else
        return !0;
    })), d = x(1), r = b(() => Math.ceil(i.value.length / parseInt(t.pageSize))), v = b(() => {
      const f = d.value < r.value ? d.value * t.pageSize : i.value.length;
      return {
        start: (d.value - 1) * t.pageSize + 1,
        end: f
      };
    }), h = b(() => t.paginate ? i.value.slice(
      (d.value - 1) * parseInt(t.pageSize),
      d.value * parseInt(t.pageSize)
    ) : i.value), g = () => {
      d.value < r.value && d.value++;
    }, m = () => {
      d.value > 1 && d.value--;
    };
    return R(a, () => {
      d.value > 1 && (d.value = 1);
    }), M("columns", t.columns), (f, V) => (s(), o("div", He, [
      l("div", Xe, [
        l("div", Je, [
          t.title ? (s(), o("div", Qe, u(t.title), 1)) : p("", !0),
          t.description ? (s(), o("div", We, u(t.description), 1)) : p("", !0),
          t.searchKey ? (s(), o("div", Ye, [
            q(U, {
              modelValue: a.value,
              "onUpdate:modelValue": V[0] || (V[0] = (w) => a.value = w),
              type: "text",
              label: "Search"
            }, null, 8, ["modelValue"])
          ])) : p("", !0),
          _(e).actions ? (s(), o("div", et, [
            c(f.$slots, "actions")
          ])) : p("", !0)
        ]),
        _(e).header ? (s(), o("div", tt, [
          c(f.$slots, "header")
        ])) : p("", !0)
      ]),
      l("div", {
        class: "cf-data-table__body",
        style: Z(`--columns: ${t.columns.length}`)
      }, [
        l("div", st, [
          (s(!0), o(S, null, B(t.columns, (w) => (s(), o("div", {
            key: w.key
          }, u(w.label), 1))), 128))
        ]),
        l("div", lt, [
          (s(!0), o(S, null, B(_(h), (w) => (s(), $(Ge, {
            key: w._id || w[t.itemKey],
            data: w,
            expandable: t.expandable
          }, {
            default: y((O) => [
              c(f.$slots, "item-drawer", {
                item: O.item
              })
            ]),
            _: 2
          }, 1032, ["data", "expandable"]))), 128))
        ])
      ], 4),
      t.paginate ? (s(), o("div", ot, [
        l("div", at, [
          l("button", {
            disabled: d.value <= 1,
            onClick: m
          }, dt, 8, nt),
          l("button", {
            disabled: d.value >= _(r),
            onClick: g
          }, ct, 8, rt),
          _(i).length ? (s(), o("div", _t, [
            l("b", null, u(`${_(v).start} to ${_(v).end}`), 1),
            z(" of "),
            l("b", null, u(_(i).length), 1)
          ])) : p("", !0)
        ])
      ])) : p("", !0)
    ]));
  }
};
const pt = { class: "cf-sidebar-nav" }, ft = /* @__PURE__ */ l("hr", null, null, -1), vt = /* @__PURE__ */ l("span", { class: "material-symbols-outlined" }, null, -1), bt = /* @__PURE__ */ l("span", null, "Collapse sidebar", -1), mt = [
  vt,
  bt
], ht = {
  __name: "Sidebar",
  setup(n) {
    const t = x(!1), e = b(() => ({
      "cf-sidebar": !0,
      "cf-sidebar--toggled": t.value
    }));
    return (a, i) => (s(), o("aside", {
      class: k(_(e))
    }, [
      l("nav", pt, [
        c(a.$slots, "default"),
        ft
      ]),
      l("button", {
        class: "cf-sidebar-toggle",
        onClick: i[0] || (i[0] = (d) => t.value = !t.value)
      }, mt)
    ], 2));
  }
};
const Ds = {
  __name: "DefaultLayout",
  setup(n) {
    return I(() => {
      document.body.dataset.layout = "default";
    }), (t, e) => (s(), o(S, null, [
      q(le, null, {
        left: y(() => [
          c(t.$slots, "brand")
        ]),
        right: y(() => [
          c(t.$slots, "navigation")
        ]),
        _: 3
      }),
      q(ht, null, {
        default: y(() => [
          c(t.$slots, "sidebar")
        ]),
        _: 3
      }),
      l("main", null, [
        c(t.$slots, "main")
      ])
    ], 64));
  }
};
const yt = { class: "cf-dialog-header" }, gt = { class: "cf-dialog__title" }, $t = { key: 0 }, kt = { class: "cf-dialog-body" }, wt = { class: "cf-dialog-footer" }, xt = /* @__PURE__ */ l("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ l("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), St = [
  xt
], Ls = {
  __name: "Dialog",
  props: {
    title: String,
    description: String
  },
  emits: ["close"],
  setup(n, { emit: t }) {
    const e = n, a = x(null);
    return I(() => {
      a.value.showModal(), a.value.addEventListener("close", () => {
        t("close");
      });
    }), (i, d) => (s(), o("dialog", {
      class: "cf-dialog",
      ref_key: "dialog",
      ref: a
    }, [
      l("div", yt, [
        l("div", gt, u(e.title), 1),
        e.description ? (s(), o("div", $t, u(e.description), 1)) : p("", !0)
      ]),
      l("div", kt, [
        c(i.$slots, "body")
      ]),
      l("div", wt, [
        c(i.$slots, "footer")
      ]),
      l("button", {
        class: "cf-dialog-close",
        onClick: d[0] || (d[0] = (r) => t("close"))
      }, St)
    ], 512));
  }
};
const Bt = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, Vt = { class: "material-symbols-outlined" }, Ct = { class: "cf-dropdown-item__label" }, Dt = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, Lt = { class: "material-symbols-outlined" }, qt = { class: "cf-dropdown-item__label" }, qs = {
  __name: "DropdownItem",
  props: {
    icon: String,
    to: String,
    large: Boolean
  },
  setup(n) {
    const t = n, e = b(() => ({
      "cf-dropdown-item": !0,
      "cf-dropdown-item--large": t.large
    }));
    return (a, i) => {
      const d = C("router-link");
      return n.to ? (s(), $(d, {
        key: 1,
        class: k(_(e)),
        to: n.to
      }, {
        default: y(() => [
          n.icon ? (s(), o("div", Dt, [
            l("span", Lt, u(n.icon), 1)
          ])) : p("", !0),
          l("div", qt, [
            c(a.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["class", "to"])) : (s(), o("button", {
        key: 0,
        class: k(_(e))
      }, [
        n.icon ? (s(), o("div", Bt, [
          l("span", Vt, u(n.icon), 1)
        ])) : p("", !0),
        l("div", Ct, [
          c(a.$slots, "default")
        ])
      ], 2));
    };
  }
};
const zt = { class: "cf-drop-zone" }, At = ["onDrop"], Tt = { class: "cf-drop-zone-box__label" }, Mt = { class: "cf-drop-zone-box__action" }, Nt = /* @__PURE__ */ l("span", null, "select from device", -1), Ft = ["required"], It = {
  key: 0,
  class: "cf-drop-zone-box__helper"
}, Pt = {
  key: 1,
  class: "cf-drop-zone-list"
}, Kt = /* @__PURE__ */ l("div", { class: "cf-drop-zone-list__header" }, null, -1), Ut = { class: "cf-drop-zone-list__item" }, Ot = /* @__PURE__ */ l("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "12",
  height: "12"
}, [
  /* @__PURE__ */ l("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), Et = [
  Ot
], zs = {
  __name: "DropZone",
  props: {
    modelValue: File,
    label: {
      type: String,
      default: "Add your file here."
    },
    max: {
      type: [Number, String],
      default: 0
    },
    accept: String,
    required: Boolean
  },
  emits: ["update:modelValue", "add", "cancel"],
  setup(n, { emit: t }) {
    const e = n, a = x(null), i = b(() => !!(e.required && !e.modelValue)), d = b(() => {
      if (e.modelValue) {
        const f = (e.modelValue.size / 1048576).toFixed(0), V = (f / 1e3).toFixed(1);
        return f < 100 ? `${f} MB` : `${V} GB`;
      } else
        return "0 MB";
    }), r = (m) => {
      const f = m.target.files[0];
      h(f);
    }, v = (m) => {
      const f = m.dataTransfer.files[0];
      h(f);
    }, h = (m) => {
      const f = parseInt(e.max) * 1048576;
      f && f < m.size ? (a.value.value = "", alert(`File cannot exceed ${e.max} MB`)) : (t("update:modelValue", m), t("add", m));
    }, g = () => {
      t("update:modelValue", null), t("cancel");
    };
    return (m, f) => (s(), o("div", zt, [
      n.modelValue ? (s(), o("div", Pt, [
        Kt,
        l("div", Ut, [
          l("div", null, u(e.modelValue.name), 1),
          l("div", null, u(_(d)), 1),
          l("button", { onClick: g }, Et)
        ])
      ])) : (s(), o("div", {
        key: 0,
        class: "cf-drop-zone-box",
        onDrop: A(v, ["prevent"]),
        onDragenter: f[0] || (f[0] = A(() => {
        }, ["prevent"])),
        onDragover: f[1] || (f[1] = A(() => {
        }, ["prevent"])),
        onDragleave: f[2] || (f[2] = A(() => {
        }, ["prevent"]))
      }, [
        l("div", Tt, u(e.label), 1),
        l("label", Mt, [
          z(" Drag and drop or "),
          Nt,
          l("input", {
            type: "file",
            ref_key: "input",
            ref: a,
            required: _(i),
            onChange: r
          }, null, 40, Ft)
        ]),
        e.max ? (s(), o("div", It, " Files larger than " + u(e.max) + " MB cannot be uploaded ", 1)) : p("", !0)
      ], 40, At))
    ]));
  }
};
const jt = ["value", "max"], As = {
  __name: "Progress",
  props: {
    value: {
      type: [Number, String],
      default: 0
    },
    max: {
      type: [Number, String],
      default: 100
    }
  },
  setup(n) {
    const t = n;
    return (e, a) => (s(), o("progress", {
      class: "cf-progress",
      value: t.value,
      max: t.max
    }, u(n.value) + "% ", 9, jt));
  }
};
const Rt = { class: "cf-sidebar-link__icon" }, Zt = { class: "material-symbols-outlined" }, Gt = { class: "cf-sidebar-link__label" }, Ht = ["href"], Xt = { class: "cf-sidebar-link__icon" }, Jt = { class: "material-symbols-outlined" }, Qt = { class: "cf-sidebar-link__label" }, Ts = {
  __name: "SidebarLink",
  props: {
    to: String,
    href: String,
    icon: String
  },
  setup(n) {
    const t = n;
    return (e, a) => {
      const i = C("router-link");
      return n.to ? (s(), $(i, {
        key: 0,
        class: "cf-sidebar-link",
        to: t.to
      }, {
        default: y(() => [
          l("div", Rt, [
            l("span", Zt, u(n.icon), 1)
          ]),
          l("div", Gt, [
            c(e.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["to"])) : (s(), o("a", {
        key: 1,
        class: "cf-sidebar-link",
        href: n.href
      }, [
        l("div", Xt, [
          l("span", Jt, u(n.icon), 1)
        ]),
        l("div", Qt, [
          c(e.$slots, "default")
        ])
      ], 8, Ht));
    };
  }
};
const Wt = {}, Yt = { class: "cf-spinner" }, es = /* @__PURE__ */ l("div", null, null, -1), ts = /* @__PURE__ */ l("div", null, null, -1), ss = /* @__PURE__ */ l("div", null, null, -1), ls = /* @__PURE__ */ l("div", null, null, -1), os = [
  es,
  ts,
  ss,
  ls
];
function as(n, t) {
  return s(), o("div", Yt, os);
}
const Ms = /* @__PURE__ */ P(Wt, [["render", as]]);
const ns = { class: "cf-switch" }, is = ["value", "true-value", "false-value", "disabled"], ds = {
  key: 0,
  class: "cf-switch__label"
}, Ns = {
  __name: "Switch",
  props: {
    modelValue: [Number, String, Boolean],
    label: String,
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(n, { emit: t }) {
    const e = n, a = b({
      get() {
        return e.modelValue;
      },
      set(i) {
        t("update:modelValue", i);
      }
    });
    return (i, d) => (s(), o("div", ns, [
      L(l("input", {
        class: "cf-switch__box",
        "onUpdate:modelValue": d[0] || (d[0] = (r) => D(a) ? a.value = r : null),
        type: "checkbox",
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        disabled: e.disabled
      }, null, 8, is), [
        [G, _(a)]
      ]),
      e.label ? (s(), o("div", ds, u(e.label), 1)) : p("", !0)
    ]));
  }
};
const rs = { class: "cf-navigation-tabs" }, Fs = {
  __name: "TabNavigation",
  props: {
    tabs: Array
  },
  setup(n) {
    const t = n;
    return (e, a) => {
      const i = C("router-link");
      return s(), o("nav", rs, [
        l("ul", null, [
          (s(!0), o(S, null, B(t.tabs, (d, r) => (s(), o("li", { key: r }, [
            q(i, {
              to: d.to
            }, {
              default: y(() => [
                z(u(d.label), 1)
              ]),
              _: 2
            }, 1032, ["to"])
          ]))), 128))
        ])
      ]);
    };
  }
};
const us = { class: "cf-tag" }, cs = /* @__PURE__ */ l("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ l("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), _s = [
  cs
], ps = {
  __name: "Tag",
  props: {
    removable: {
      type: Boolean,
      default: !0
    }
  },
  emits: ["remove"],
  setup(n, { emit: t }) {
    const e = n;
    return (a, i) => (s(), o("div", us, [
      l("span", null, [
        c(a.$slots, "default")
      ]),
      e.removable ? (s(), o("button", {
        key: 0,
        onClick: i[0] || (i[0] = (d) => t("remove"))
      }, _s)) : p("", !0)
    ]));
  }
};
const fs = ["inert"], vs = { key: 0 }, bs = { class: "cf-tags-field__input" }, ms = ["required"], hs = { class: "cf-tags-field__tags" }, ys = { key: 1 }, Is = {
  __name: "TagsField",
  props: {
    modelValue: Array,
    label: String,
    buttonText: {
      type: String,
      default: "Add"
    },
    prefix: String,
    options: Array,
    helper: String,
    disabled: Boolean,
    required: Boolean
  },
  emits: ["update:modelValue"],
  setup(n, { emit: t }) {
    const e = n, a = x(!1), i = x(""), d = b(() => e.options ? e.options.filter((h) => !e.modelValue.includes(h)) : null), r = () => {
      if (!i.value || e.disabled)
        return !1;
      const h = e.modelValue;
      h.push(i.value), t("update:modelValue", h), i.value = "", a.value = !1;
    }, v = (h) => {
      if (e.disabled)
        return !1;
      const g = e.modelValue;
      g.splice(h, 1), t("update:modelValue", g);
    };
    return (h, g) => (s(), o("div", {
      class: "cf-tags-field",
      inert: e.disabled
    }, [
      e.label ? (s(), o("label", vs, u(e.label), 1)) : p("", !0),
      l("div", bs, [
        a.value ? (s(), $(U, {
          key: 0,
          modelValue: i.value,
          "onUpdate:modelValue": g[0] || (g[0] = (m) => i.value = m),
          type: e.options ? "select" : "text",
          prefix: e.prefix,
          options: _(d),
          onKeydown: H(r, ["enter"]),
          onChange: r,
          required: ""
        }, null, 8, ["modelValue", "type", "prefix", "options", "onKeydown"])) : (s(), $(ge, {
          key: 1,
          color: "blue",
          onClick: g[1] || (g[1] = (m) => a.value = !0)
        }, {
          default: y(() => [
            z(u(e.buttonText), 1)
          ]),
          _: 1
        })),
        l("input", {
          class: "cf-tags-field__input__faux",
          type: "text",
          required: e.required && !e.modelValue.length
        }, null, 8, ms)
      ]),
      l("div", hs, [
        (s(!0), o(S, null, B(e.modelValue, (m, f) => (s(), $(ps, {
          key: m,
          onRemove: (V) => v(f)
        }, {
          default: y(() => [
            z(u(e.prefix) + " " + u(m), 1)
          ]),
          _: 2
        }, 1032, ["onRemove"]))), 128))
      ]),
      e.helper ? (s(), o("small", ys, u(e.helper), 1)) : p("", !0)
    ], 8, fs));
  }
};
export {
  $s as CfActionCard,
  le as CfAppBar,
  ks as CfAppBarLink,
  ws as CfAppView,
  xs as CfBanner,
  Be as CfChoice,
  Vs as CfChoiceList,
  Cs as CfDataTable,
  Ds as CfDefaultLayout,
  Ls as CfDialog,
  zs as CfDropZone,
  ae as CfDropdown,
  qs as CfDropdownItem,
  U as CfField,
  Ss as CfFilledButton,
  ge as CfOutlinedButton,
  As as CfProgress,
  ht as CfSidebar,
  Ts as CfSidebarLink,
  Ms as CfSpinner,
  Ns as CfSwitch,
  Fs as CfTabNavigation,
  ps as CfTag,
  Is as CfTagsField,
  Bs as CfTextButton
};
